library facts;

import 'package:sunny_sdk_core/model_exports.dart';
import 'package:sunny_service_stubs/models/facts/facts.dart';

import 'model/assisted_task.dart';
import 'model/assisted_task_list.dart';
import 'model/assisted_tasks.dart';
import 'model/birthday.dart';
import 'model/birthday_list.dart';
import 'model/book_club.dart';
import 'model/book_club_list.dart';
import 'model/book_club_member.dart';
import 'model/book_club_member_list.dart';
import 'model/church.dart';
import 'model/church_list.dart';
import 'model/college.dart';
import 'model/college_list.dart';
import 'model/college_student.dart';
import 'model/college_student_list.dart';
import 'model/congregant.dart';
import 'model/congregant_list.dart';
import 'model/contact_extended_props.dart';
import 'model/contact_extended_props_list.dart';
import 'model/contact_interests.dart';
import 'model/contact_interests_list.dart';
import 'model/dimensions.dart';
import 'model/employee.dart';
import 'model/employee_list.dart';
import 'model/employer.dart';
import 'model/employer_list.dart';
import 'model/event_based_due_config.dart';
import 'model/event_type.dart';
import 'model/expression_due_config.dart';
import 'model/fact_list.dart';
import 'model/facts.dart';
import 'model/family.dart';
import 'model/family_association.dart';
import 'model/family_association_list.dart';
import 'model/family_list.dart';
import 'model/gender.dart';
import 'model/gift.dart';
import 'model/gift_list.dart';
import 'model/hometown.dart';
import 'model/hometown_list.dart';
import 'model/membership_list.dart';
import 'model/memory.dart';
import 'model/memory_list.dart';
import 'model/meta_date_due_config.dart';
import 'model/milestone.dart';
import 'model/milestone_list.dart';
import 'model/note.dart';
import 'model/note_list.dart';
import 'model/organization_list.dart';
import 'model/orientation.dart';
import 'model/owes_money.dart';
import 'model/owes_money_list.dart';
import 'model/payment.dart';
import 'model/payment_list.dart';
import 'model/pet.dart';
import 'model/pet_list.dart';
import 'model/phase.dart';
import 'model/phase_list.dart';
import 'model/phone_with_extension.dart';
import 'model/player.dart';
import 'model/player_list.dart';
import 'model/possession.dart';
import 'model/possession_list.dart';
import 'model/prep_school.dart';
import 'model/prep_school_list.dart';
import 'model/prep_school_student.dart';
import 'model/prep_school_student_list.dart';
import 'model/reaction.dart';
import 'model/reaction_list.dart';
import 'model/recurrence.dart';
import 'model/recurring_time_span.dart';
import 'model/remember.dart';
import 'model/remember_list.dart';
import 'model/smart_date_due_config.dart';
import 'model/task_due_config.dart';
import 'model/task_fact_for_m_model.dart';
import 'model/task_fact_list.dart';
import 'model/team.dart';
import 'model/team_list.dart';
import 'model/time_sensitivity.dart';
import 'model/tradition.dart';
import 'model/tradition_list.dart';
import 'model/trait.dart';
import 'model/trait_list.dart';

export 'package:sunny_service_stubs/models/facts/facts.dart';

export 'api/assisted_task_api.dart';
export 'api/birthday_api.dart';
export 'api/book_club_api.dart';
export 'api/book_club_member_api.dart';
export 'api/church_api.dart';
export 'api/college_api.dart';
export 'api/college_student_api.dart';
export 'api/congregant_api.dart';
export 'api/contact_extended_props_api.dart';
export 'api/contact_interests_api.dart';
export 'api/employee_api.dart';
export 'api/employer_api.dart';
export 'api/fact_api.dart';
export 'api/family_api.dart';
export 'api/family_association_api.dart';
export 'api/gift_api.dart';
export 'api/hometown_api.dart';
export 'api/membership_api.dart';
export 'api/memory_api.dart';
export 'api/milestone_api.dart';
export 'api/note_api.dart';
export 'api/organization_api.dart';
export 'api/owes_money_api.dart';
export 'api/payment_api.dart';
export 'api/pet_api.dart';
export 'api/phase_api.dart';
export 'api/player_api.dart';
export 'api/possession_api.dart';
export 'api/prep_school_api.dart';
export 'api/prep_school_student_api.dart';
export 'api/reaction_api.dart';
export 'api/remember_api.dart';
export 'api/task_fact_api.dart';
export 'api/team_api.dart';
export 'api/tradition_api.dart';
export 'api/trait_api.dart';
export 'ext/ext.dart';
export 'model/assisted_task.dart';
export 'model/assisted_task_list.dart';
export 'model/assisted_tasks.dart';
export 'model/birthday.dart';
export 'model/birthday_list.dart';
export 'model/book_club.dart';
export 'model/book_club_list.dart';
export 'model/book_club_member.dart';
export 'model/book_club_member_list.dart';
export 'model/church.dart';
export 'model/church_list.dart';
export 'model/college.dart';
export 'model/college_list.dart';
export 'model/college_student.dart';
export 'model/college_student_list.dart';
export 'model/congregant.dart';
export 'model/congregant_list.dart';
export 'model/contact_extended_props.dart';
export 'model/contact_extended_props_list.dart';
export 'model/contact_interests.dart';
export 'model/contact_interests_list.dart';
export 'model/dimensions.dart';
export 'model/employee.dart';
export 'model/employee_list.dart';
export 'model/employer.dart';
export 'model/employer_list.dart';
export 'model/event_based_due_config.dart';
export 'model/event_type.dart';
export 'model/expression_due_config.dart';
export 'model/fact.dart';
export 'model/fact_list.dart';
export 'model/facts.dart';
export 'model/family.dart';
export 'model/family_association.dart';
export 'model/family_association_list.dart';
export 'model/family_list.dart';
export 'model/gender.dart';
export 'model/gift.dart';
export 'model/gift_list.dart';
export 'model/hometown.dart';
export 'model/hometown_list.dart';
export 'model/membership.dart';
export 'model/membership_list.dart';
export 'model/memory.dart';
export 'model/memory_list.dart';
export 'model/meta_date_due_config.dart';
export 'model/milestone.dart';
export 'model/milestone_list.dart';
export 'model/note.dart';
export 'model/note_list.dart';
export 'model/organization.dart';
export 'model/organization_list.dart';
export 'model/orientation.dart';
export 'model/owes_money.dart';
export 'model/owes_money_list.dart';
export 'model/payment.dart';
export 'model/payment_list.dart';
export 'model/pet.dart';
export 'model/pet_list.dart';
export 'model/phase.dart';
export 'model/phase_list.dart';
export 'model/phone_with_extension.dart';
export 'model/player.dart';
export 'model/player_list.dart';
export 'model/possession.dart';
export 'model/possession_list.dart';
export 'model/prep_school.dart';
export 'model/prep_school_list.dart';
export 'model/prep_school_student.dart';
export 'model/prep_school_student_list.dart';
export 'model/reaction.dart';
export 'model/reaction_list.dart';
export 'model/recurrence.dart';
export 'model/recurring_time_span.dart';
export 'model/remember.dart';
export 'model/remember_list.dart';
export 'model/smart_date_due_config.dart';
export 'model/task_due_config.dart';
export 'model/task_fact.dart';
export 'model/task_fact_for_m_model.dart';
export 'model/task_fact_list.dart';
export 'model/team.dart';
export 'model/team_list.dart';
export 'model/time_sensitivity.dart';
export 'model/tradition.dart';
export 'model/tradition_list.dart';
export 'model/trait.dart';
export 'model/trait_list.dart';

const factModuleRef = MModuleRef.ofParts("sunny", "fact", "0.0.1");

registerFactsModels(MModelRegistry modelRegistry, MEnumRegistry enumRegistry) {
  modelRegistry.register(
      AssistedTaskRef, (json) => AssistedTask(json as Map<String, dynamic>));
  IAssistedTask.of = AssistedTask.of;
  IAssistedTask.fromJson = AssistedTask.fromJson;

  modelRegistry.register(AssistedTaskListRef,
      (json) => AssistedTaskList(json as Map<String, dynamic>));
  IAssistedTaskList.of = AssistedTaskList.of;
  IAssistedTaskList.fromJson = AssistedTaskList.fromJson;

  modelRegistry.register(
      AssistedTasksRef, (json) => AssistedTasks(json as Map<String, dynamic>));
  IAssistedTasks.of = AssistedTasks.of;
  IAssistedTasks.fromJson = AssistedTasks.fromJson;

  modelRegistry.register(
      BirthdayRef, (json) => Birthday(json as Map<String, dynamic>));
  IBirthday.of = Birthday.of;
  IBirthday.fromJson = Birthday.fromJson;

  modelRegistry.register(
      BirthdayListRef, (json) => BirthdayList(json as Map<String, dynamic>));
  IBirthdayList.of = BirthdayList.of;
  IBirthdayList.fromJson = BirthdayList.fromJson;

  modelRegistry.register(
      BookClubRef, (json) => BookClub(json as Map<String, dynamic>));
  IBookClub.of = BookClub.of;
  IBookClub.fromJson = BookClub.fromJson;

  modelRegistry.register(
      BookClubListRef, (json) => BookClubList(json as Map<String, dynamic>));
  IBookClubList.of = BookClubList.of;
  IBookClubList.fromJson = BookClubList.fromJson;

  modelRegistry.register(BookClubMemberRef,
      (json) => BookClubMember(json as Map<String, dynamic>));
  IBookClubMember.of = BookClubMember.of;
  IBookClubMember.fromJson = BookClubMember.fromJson;

  modelRegistry.register(BookClubMemberListRef,
      (json) => BookClubMemberList(json as Map<String, dynamic>));
  IBookClubMemberList.of = BookClubMemberList.of;
  IBookClubMemberList.fromJson = BookClubMemberList.fromJson;

  modelRegistry.register(
      ChurchRef, (json) => Church(json as Map<String, dynamic>));
  IChurch.of = Church.of;
  IChurch.fromJson = Church.fromJson;

  modelRegistry.register(
      ChurchListRef, (json) => ChurchList(json as Map<String, dynamic>));
  IChurchList.of = ChurchList.of;
  IChurchList.fromJson = ChurchList.fromJson;

  modelRegistry.register(
      CollegeRef, (json) => College(json as Map<String, dynamic>));
  ICollege.of = College.of;
  ICollege.fromJson = College.fromJson;

  modelRegistry.register(
      CollegeListRef, (json) => CollegeList(json as Map<String, dynamic>));
  ICollegeList.of = CollegeList.of;
  ICollegeList.fromJson = CollegeList.fromJson;

  modelRegistry.register(CollegeStudentRef,
      (json) => CollegeStudent(json as Map<String, dynamic>));
  ICollegeStudent.of = CollegeStudent.of;
  ICollegeStudent.fromJson = CollegeStudent.fromJson;

  modelRegistry.register(CollegeStudentListRef,
      (json) => CollegeStudentList(json as Map<String, dynamic>));
  ICollegeStudentList.of = CollegeStudentList.of;
  ICollegeStudentList.fromJson = CollegeStudentList.fromJson;

  modelRegistry.register(
      CongregantRef, (json) => Congregant(json as Map<String, dynamic>));
  ICongregant.of = Congregant.of;
  ICongregant.fromJson = Congregant.fromJson;

  modelRegistry.register(CongregantListRef,
      (json) => CongregantList(json as Map<String, dynamic>));
  ICongregantList.of = CongregantList.of;
  ICongregantList.fromJson = CongregantList.fromJson;

  modelRegistry.register(ContactExtendedPropsRef,
      (json) => ContactExtendedProps(json as Map<String, dynamic>));
  IContactExtendedProps.of = ContactExtendedProps.of;
  IContactExtendedProps.fromJson = ContactExtendedProps.fromJson;

  modelRegistry.register(ContactExtendedPropsListRef,
      (json) => ContactExtendedPropsList(json as Map<String, dynamic>));
  IContactExtendedPropsList.of = ContactExtendedPropsList.of;
  IContactExtendedPropsList.fromJson = ContactExtendedPropsList.fromJson;

  modelRegistry.register(ContactInterestsRef,
      (json) => ContactInterests(json as Map<String, dynamic>));
  IContactInterests.of = ContactInterests.of;
  IContactInterests.fromJson = ContactInterests.fromJson;

  modelRegistry.register(ContactInterestsListRef,
      (json) => ContactInterestsList(json as Map<String, dynamic>));
  IContactInterestsList.of = ContactInterestsList.of;
  IContactInterestsList.fromJson = ContactInterestsList.fromJson;

  modelRegistry.register(
      DimensionsRef, (json) => Dimensions(json as Map<String, dynamic>));
  IDimensions.of = Dimensions.of;
  IDimensions.fromJson = Dimensions.fromJson;

  modelRegistry.register(
      EmployeeRef, (json) => Employee(json as Map<String, dynamic>));
  IEmployee.of = Employee.of;
  IEmployee.fromJson = Employee.fromJson;

  modelRegistry.register(
      EmployeeListRef, (json) => EmployeeList(json as Map<String, dynamic>));
  IEmployeeList.of = EmployeeList.of;
  IEmployeeList.fromJson = EmployeeList.fromJson;

  modelRegistry.register(
      EmployerRef, (json) => Employer(json as Map<String, dynamic>));
  IEmployer.of = Employer.of;
  IEmployer.fromJson = Employer.fromJson;

  modelRegistry.register(
      EmployerListRef, (json) => EmployerList(json as Map<String, dynamic>));
  IEmployerList.of = EmployerList.of;
  IEmployerList.fromJson = EmployerList.fromJson;

  modelRegistry.register(EventBasedDueConfigRef,
      (json) => EventBasedDueConfig(json as Map<String, dynamic>));
  IEventBasedDueConfig.of = EventBasedDueConfig.of;
  IEventBasedDueConfig.fromJson = EventBasedDueConfig.fromJson;

  EventType.init();
  enumRegistry.register("sunny.fact.definitions.eventType",
      values: IEventType.values,
      factory: (value) => EventType.fromJson(value)!);
  modelRegistry.register(ExpressionDueConfigRef,
      (json) => ExpressionDueConfig(json as Map<String, dynamic>));
  IExpressionDueConfig.of = ExpressionDueConfig.of;
  IExpressionDueConfig.fromJson = ExpressionDueConfig.fromJson;

  modelRegistry.register(
      FactRef,
      (json) =>
          throw Exception("Unable to instantiate abstract entity $FactRef"));

  modelRegistry.register(
      FactListRef, (json) => FactList(json as Map<String, dynamic>));
  IFactList.of = FactList.of;
  IFactList.fromJson = FactList.fromJson;

  modelRegistry.register(
      FactsRef, (json) => Facts(json as Map<String, dynamic>));
  IFacts.of = Facts.of;
  IFacts.fromJson = Facts.fromJson;

  modelRegistry.register(
      FamilyRef, (json) => Family(json as Map<String, dynamic>));
  IFamily.of = Family.of;
  IFamily.fromJson = Family.fromJson;

  modelRegistry.register(FamilyAssociationRef,
      (json) => FamilyAssociation(json as Map<String, dynamic>));
  IFamilyAssociation.of = FamilyAssociation.of;
  IFamilyAssociation.fromJson = FamilyAssociation.fromJson;

  modelRegistry.register(FamilyAssociationListRef,
      (json) => FamilyAssociationList(json as Map<String, dynamic>));
  IFamilyAssociationList.of = FamilyAssociationList.of;
  IFamilyAssociationList.fromJson = FamilyAssociationList.fromJson;

  modelRegistry.register(
      FamilyListRef, (json) => FamilyList(json as Map<String, dynamic>));
  IFamilyList.of = FamilyList.of;
  IFamilyList.fromJson = FamilyList.fromJson;

  Gender.init();
  enumRegistry.register("mverse.core.definitions.gender",
      values: IGender.values, factory: (value) => Gender.fromJson(value)!);
  modelRegistry.register(GiftRef, (json) => Gift(json as Map<String, dynamic>));
  IGift.of = Gift.of;
  IGift.fromJson = Gift.fromJson;

  modelRegistry.register(
      GiftListRef, (json) => GiftList(json as Map<String, dynamic>));
  IGiftList.of = GiftList.of;
  IGiftList.fromJson = GiftList.fromJson;

  modelRegistry.register(
      HometownRef, (json) => Hometown(json as Map<String, dynamic>));
  IHometown.of = Hometown.of;
  IHometown.fromJson = Hometown.fromJson;

  modelRegistry.register(
      HometownListRef, (json) => HometownList(json as Map<String, dynamic>));
  IHometownList.of = HometownList.of;
  IHometownList.fromJson = HometownList.fromJson;

  modelRegistry.register(
      MembershipRef,
      (json) => throw Exception(
          "Unable to instantiate abstract entity $MembershipRef"));

  modelRegistry.register(MembershipListRef,
      (json) => MembershipList(json as Map<String, dynamic>));
  IMembershipList.of = MembershipList.of;
  IMembershipList.fromJson = MembershipList.fromJson;

  modelRegistry.register(
      MemoryRef, (json) => Memory(json as Map<String, dynamic>));
  IMemory.of = Memory.of;
  IMemory.fromJson = Memory.fromJson;

  modelRegistry.register(
      MemoryListRef, (json) => MemoryList(json as Map<String, dynamic>));
  IMemoryList.of = MemoryList.of;
  IMemoryList.fromJson = MemoryList.fromJson;

  modelRegistry.register(MetaDateDueConfigRef,
      (json) => MetaDateDueConfig(json as Map<String, dynamic>));
  IMetaDateDueConfig.of = MetaDateDueConfig.of;
  IMetaDateDueConfig.fromJson = MetaDateDueConfig.fromJson;

  modelRegistry.register(
      MilestoneRef, (json) => Milestone(json as Map<String, dynamic>));
  IMilestone.of = Milestone.of;
  IMilestone.fromJson = Milestone.fromJson;

  modelRegistry.register(
      MilestoneListRef, (json) => MilestoneList(json as Map<String, dynamic>));
  IMilestoneList.of = MilestoneList.of;
  IMilestoneList.fromJson = MilestoneList.fromJson;

  modelRegistry.register(NoteRef, (json) => Note(json as Map<String, dynamic>));
  INote.of = Note.of;
  INote.fromJson = Note.fromJson;

  modelRegistry.register(
      NoteListRef, (json) => NoteList(json as Map<String, dynamic>));
  INoteList.of = NoteList.of;
  INoteList.fromJson = NoteList.fromJson;

  modelRegistry.register(
      OrganizationRef,
      (json) => throw Exception(
          "Unable to instantiate abstract entity $OrganizationRef"));

  modelRegistry.register(OrganizationListRef,
      (json) => OrganizationList(json as Map<String, dynamic>));
  IOrganizationList.of = OrganizationList.of;
  IOrganizationList.fromJson = OrganizationList.fromJson;

  Orientation.init();
  enumRegistry.register("sunny.content.definitions.orientation",
      values: IOrientation.values,
      factory: (value) => Orientation.fromJson(value)!);
  modelRegistry.register(
      OwesMoneyRef, (json) => OwesMoney(json as Map<String, dynamic>));
  IOwesMoney.of = OwesMoney.of;
  IOwesMoney.fromJson = OwesMoney.fromJson;

  modelRegistry.register(
      OwesMoneyListRef, (json) => OwesMoneyList(json as Map<String, dynamic>));
  IOwesMoneyList.of = OwesMoneyList.of;
  IOwesMoneyList.fromJson = OwesMoneyList.fromJson;

  modelRegistry.register(
      PaymentRef, (json) => Payment(json as Map<String, dynamic>));
  IPayment.of = Payment.of;
  IPayment.fromJson = Payment.fromJson;

  modelRegistry.register(
      PaymentListRef, (json) => PaymentList(json as Map<String, dynamic>));
  IPaymentList.of = PaymentList.of;
  IPaymentList.fromJson = PaymentList.fromJson;

  modelRegistry.register(PetRef, (json) => Pet(json as Map<String, dynamic>));
  IPet.of = Pet.of;
  IPet.fromJson = Pet.fromJson;

  modelRegistry.register(
      PetListRef, (json) => PetList(json as Map<String, dynamic>));
  IPetList.of = PetList.of;
  IPetList.fromJson = PetList.fromJson;

  modelRegistry.register(
      PhaseRef, (json) => Phase(json as Map<String, dynamic>));
  IPhase.of = Phase.of;
  IPhase.fromJson = Phase.fromJson;

  modelRegistry.register(
      PhaseListRef, (json) => PhaseList(json as Map<String, dynamic>));
  IPhaseList.of = PhaseList.of;
  IPhaseList.fromJson = PhaseList.fromJson;

  modelRegistry.register(PhoneWithExtensionRef,
      (json) => PhoneWithExtension(json as Map<String, dynamic>));
  IPhoneWithExtension.of = PhoneWithExtension.of;
  IPhoneWithExtension.fromJson = PhoneWithExtension.fromJson;

  modelRegistry.register(
      PlayerRef, (json) => Player(json as Map<String, dynamic>));
  IPlayer.of = Player.of;
  IPlayer.fromJson = Player.fromJson;

  modelRegistry.register(
      PlayerListRef, (json) => PlayerList(json as Map<String, dynamic>));
  IPlayerList.of = PlayerList.of;
  IPlayerList.fromJson = PlayerList.fromJson;

  modelRegistry.register(
      PossessionRef, (json) => Possession(json as Map<String, dynamic>));
  IPossession.of = Possession.of;
  IPossession.fromJson = Possession.fromJson;

  modelRegistry.register(PossessionListRef,
      (json) => PossessionList(json as Map<String, dynamic>));
  IPossessionList.of = PossessionList.of;
  IPossessionList.fromJson = PossessionList.fromJson;

  modelRegistry.register(
      PrepSchoolRef, (json) => PrepSchool(json as Map<String, dynamic>));
  IPrepSchool.of = PrepSchool.of;
  IPrepSchool.fromJson = PrepSchool.fromJson;

  modelRegistry.register(PrepSchoolListRef,
      (json) => PrepSchoolList(json as Map<String, dynamic>));
  IPrepSchoolList.of = PrepSchoolList.of;
  IPrepSchoolList.fromJson = PrepSchoolList.fromJson;

  modelRegistry.register(PrepSchoolStudentRef,
      (json) => PrepSchoolStudent(json as Map<String, dynamic>));
  IPrepSchoolStudent.of = PrepSchoolStudent.of;
  IPrepSchoolStudent.fromJson = PrepSchoolStudent.fromJson;

  modelRegistry.register(PrepSchoolStudentListRef,
      (json) => PrepSchoolStudentList(json as Map<String, dynamic>));
  IPrepSchoolStudentList.of = PrepSchoolStudentList.of;
  IPrepSchoolStudentList.fromJson = PrepSchoolStudentList.fromJson;

  modelRegistry.register(
      ReactionRef, (json) => Reaction(json as Map<String, dynamic>));
  IReaction.of = Reaction.of;
  IReaction.fromJson = Reaction.fromJson;

  modelRegistry.register(
      ReactionListRef, (json) => ReactionList(json as Map<String, dynamic>));
  IReactionList.of = ReactionList.of;
  IReactionList.fromJson = ReactionList.fromJson;

  modelRegistry.register(
      RecurrenceRef, (json) => Recurrence(json as Map<String, dynamic>));
  IRecurrence.of = Recurrence.of;
  IRecurrence.fromJson = Recurrence.fromJson;

  RecurringTimeSpan.init();
  enumRegistry.register("sunny.fact.definitions.recurringTimeSpan",
      values: IRecurringTimeSpan.values,
      factory: (value) => RecurringTimeSpan.fromJson(value)!);
  modelRegistry.register(
      RememberRef, (json) => Remember(json as Map<String, dynamic>));
  IRemember.of = Remember.of;
  IRemember.fromJson = Remember.fromJson;

  modelRegistry.register(
      RememberListRef, (json) => RememberList(json as Map<String, dynamic>));
  IRememberList.of = RememberList.of;
  IRememberList.fromJson = RememberList.fromJson;

  modelRegistry.register(SmartDateDueConfigRef,
      (json) => SmartDateDueConfig(json as Map<String, dynamic>));
  ISmartDateDueConfig.of = SmartDateDueConfig.of;
  ISmartDateDueConfig.fromJson = SmartDateDueConfig.fromJson;

  modelRegistry.register(
      TaskDueConfigRef, (json) => TaskDueConfig(json as Map<String, dynamic>));
  ITaskDueConfig.of = TaskDueConfig.of;
  ITaskDueConfig.fromJson = TaskDueConfig.fromJson;

  modelRegistry.register(
      TaskFactRef,
      (json) => throw Exception(
          "Unable to instantiate abstract entity $TaskFactRef"));

  modelRegistry.register(TaskFactForMModelRef,
      (json) => TaskFactForMModel(json as Map<String, dynamic>));
  ITaskFactForMModel.of = TaskFactForMModel.of;
  ITaskFactForMModel.fromJson = TaskFactForMModel.fromJson;

  modelRegistry.register(
      TaskFactListRef, (json) => TaskFactList(json as Map<String, dynamic>));
  ITaskFactList.of = TaskFactList.of;
  ITaskFactList.fromJson = TaskFactList.fromJson;

  modelRegistry.register(TeamRef, (json) => Team(json as Map<String, dynamic>));
  ITeam.of = Team.of;
  ITeam.fromJson = Team.fromJson;

  modelRegistry.register(
      TeamListRef, (json) => TeamList(json as Map<String, dynamic>));
  ITeamList.of = TeamList.of;
  ITeamList.fromJson = TeamList.fromJson;

  TimeSensitivity.init();
  enumRegistry.register("sunny.factSchema.definitions.timeSensitivity",
      values: ITimeSensitivity.values,
      factory: (value) => TimeSensitivity.fromJson(value)!);
  modelRegistry.register(
      TraditionRef, (json) => Tradition(json as Map<String, dynamic>));
  ITradition.of = Tradition.of;
  ITradition.fromJson = Tradition.fromJson;

  modelRegistry.register(
      TraditionListRef, (json) => TraditionList(json as Map<String, dynamic>));
  ITraditionList.of = TraditionList.of;
  ITraditionList.fromJson = TraditionList.fromJson;

  modelRegistry.register(
      TraitRef, (json) => Trait(json as Map<String, dynamic>));
  ITrait.of = Trait.of;
  ITrait.fromJson = Trait.fromJson;

  modelRegistry.register(
      TraitListRef, (json) => TraitList(json as Map<String, dynamic>));
  ITraitList.of = TraitList.of;
  ITraitList.fromJson = TraitList.fromJson;
}
